"use strict";

exports.__esModule = true;
exports.removeDir = removeDir;
exports.removeDirSync = removeDirSync;

var _fs = require("fs");

var _os = require("os");

var _isPathInside = _interopRequireDefault(require("is-path-inside"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function handleError(e) {
  if (e.code === "ENOENT") {
    return true;
  } else if (e.code === "ENOTEMPTY") {
    return false;
  } else {
    return undefined;
  }
}

function validatePath(path, options) {
  if (options.unsafe) {
    return true;
  } else {
    return (0, _isPathInside["default"])(path, process.cwd()) || (0, _isPathInside["default"])(path, (0, _os.tmpdir)());
  }
}

function removeDir(_x, _x2) {
  return _removeDir.apply(this, arguments);
}

function _removeDir() {
  _removeDir = _asyncToGenerator(function* (path, options) {
    if (options === void 0) {
      options = {};
    }

    if (validatePath(path, options)) {
      var _options$recursive2;

      return _fs.promises.rmdir(path, {
        recursive: (_options$recursive2 = options.recursive) != null ? _options$recursive2 : true
      }).then(function () {
        return true;
      })["catch"](function (e) {
        return handleError(e);
      });
    } else {
      return undefined;
    }
  });
  return _removeDir.apply(this, arguments);
}

function removeDirSync(path, options) {
  if (options === void 0) {
    options = {};
  }

  if (validatePath(path, options)) {
    try {
      var _options$recursive;

      (0, _fs.rmdirSync)(path, {
        recursive: (_options$recursive = options.recursive) != null ? _options$recursive : true
      });
      return true;
    } catch (e) {
      return handleError(e);
    }
  } else {
    return undefined;
  }
}